#include "stm8s.h"

void main(void)
{
	CLK_ClockSwitchConfig(CLK_SWITCHMODE_AUTO, CLK_SOURCE_HSI, DISABLE, CLK_CURRENTCLOCKSTATE_DISABLE);
	CLK_HSIPrescalerConfig( CLK_PRESCALER_HSIDIV1 );
	CLK_SYSCLKConfig( CLK_PRESCALER_CPUDIV1 );

	GPIO_Init(GPIOD, GPIO_PIN_0, GPIO_MODE_OUT_PP_HIGH_FAST);
	
	// 0.5Sec intterrupt timer setting TIM1
	TIM1_DeInit();
	TIM1_TimeBaseInit( 1599, TIM1_COUNTERMODE_UP, 4999, 0 ); // 16MHz/1600/5000=2Hz
	TIM1_ITConfig(TIM1_IT_UPDATE, ENABLE);
	TIM1_Cmd(ENABLE);
	
	// 0.5Sec intterrupt timer setting TIM2
	TIM2_DeInit();
	TIM2_TimeBaseInit( TIM2_PRESCALER_1024, 7812 ); // 16MHz/1024/7812=2Hz
	TIM2_ITConfig(TIM2_IT_UPDATE, ENABLE);
	//TIM2_Cmd(ENABLE);

	// 0.5Sec intterrupt timer setting TIM3
	TIM3_DeInit();
	TIM3_TimeBaseInit( TIM3_PRESCALER_1024, 7812 ); // 16MHz/1024/7812=2Hz
	TIM3_ITConfig(TIM3_IT_UPDATE, ENABLE);
	//TIM3_Cmd(ENABLE);

	// 2mSec intterrupt timer setting TIM4
	TIM4_DeInit();
	TIM4_TimeBaseInit( TIM4_PRESCALER_128, 255 ); // 16MHz/128/256=488Hz
	TIM4_ITConfig(TIM4_IT_UPDATE, ENABLE);
	//TIM4_Cmd(ENABLE);
	
  enableInterrupts();

	while(1) {	}
}

void TIM1_interrupt(void) interrupt 11
{
	GPIO_WriteReverse(GPIOD, GPIO_PIN_0);
  TIM1_ClearFlag(TIM1_FLAG_UPDATE);
}

void TIM2_interrupt(void) interrupt 13
{
	GPIO_WriteReverse(GPIOD, GPIO_PIN_0);
  TIM2_ClearFlag(TIM2_FLAG_UPDATE);
}

void TIM3_interrupt(void) interrupt 15
{
	GPIO_WriteReverse(GPIOD, GPIO_PIN_0);
  TIM3_ClearFlag(TIM3_FLAG_UPDATE);
}

void TIM4_interrupt(void) interrupt 23
{
	GPIO_WriteReverse(GPIOD, GPIO_PIN_0);
  TIM4_ClearFlag(TIM4_FLAG_UPDATE);
}

#ifdef USE_FULL_ASSERT
void assert_failed(u8* file, u32 line)
{ 
  while (1)  	{	}
}
#endif
